// Generated by CoffeeScript 1.6.2
(function() {
  var NoStandAloneAt;

  module.exports = NoStandAloneAt = (function() {
    function NoStandAloneAt() {}

    NoStandAloneAt.prototype.rule = {
      name: 'no_stand_alone_at',
      level: 'ignore',
      message: '@ must not be used stand alone',
      description: "This rule checks that no stand alone @ are in use, they are\ndiscouraged. Further information in CoffeScript issue <a\nhref=\"https://github.com/jashkenas/coffee-script/issues/1601\">\n#1601</a>"
    };

    NoStandAloneAt.prototype.tokens = ["@"];

    NoStandAloneAt.prototype.lintToken = function(token, tokenApi) {
      var isDot, isIdentifier, isIndexStart, isValidProtoProperty, nextToken, protoProperty, spaced;

      nextToken = tokenApi.peek();
      spaced = token.spaced;
      isIdentifier = nextToken[0] === 'IDENTIFIER';
      isIndexStart = nextToken[0] === 'INDEX_START';
      isDot = nextToken[0] === '.';
      if (nextToken[0] === '::') {
        protoProperty = tokenApi.peek(2);
        isValidProtoProperty = protoProperty[0] === 'IDENTIFIER';
      }
      if (spaced || (!isIdentifier && !isIndexStart && !isDot && !isValidProtoProperty)) {
        return true;
      }
    };

    return NoStandAloneAt;

  })();

}).call(this);
