// Generated by CoffeeScript 1.6.2
(function() {
  var NoTrailingSemicolons, regexes,
    __slice = [].slice;

  regexes = {
    trailingSemicolon: /;\r?$/
  };

  module.exports = NoTrailingSemicolons = (function() {
    function NoTrailingSemicolons() {}

    NoTrailingSemicolons.prototype.rule = {
      name: 'no_trailing_semicolons',
      level: 'error',
      message: 'Line contains a trailing semicolon',
      description: "This rule prohibits trailing semicolons, since they are needless\ncruft in CoffeeScript.\n<pre>\n<code># This semicolon is meaningful.\nx = '1234'; console.log(x)\n\n# This semicolon is redundant.\nalert('end of line');\n</code>\n</pre>\nTrailing semicolons are forbidden by default."
    };

    NoTrailingSemicolons.prototype.lintLine = function(line, lineApi) {
      var first, hasNewLine, hasSemicolon, last, lineTokens, _i, _ref;

      lineTokens = lineApi.getLineTokens();
      if (lineTokens.length === 1 && lineTokens[0][0] === 'TERMINATOR') {
        return;
      }
      hasSemicolon = regexes.trailingSemicolon.test(line);
      _ref = lineApi.getLineTokens(), first = 2 <= _ref.length ? __slice.call(_ref, 0, _i = _ref.length - 1) : (_i = 0, []), last = _ref[_i++];
      hasNewLine = last && (last.newLine != null);
      if (hasSemicolon && !hasNewLine && lineApi.lineHasToken() && last[0] !== 'STRING') {
        return true;
      }
    };

    return NoTrailingSemicolons;

  })();

}).call(this);
